;; Font Editor 2.1
;;
;; Assembly routines


putpixel
        and (tmp),y
        cmp #$00
        beq dot
        lda #$7f
        jmp draw
dot
        lda #$2e
draw
        sty tmp2+1
        stx tmp2
        ldy tmp2
        sta ($1f),y
        ldy tmp2+1
        inx
        rts

_showchar
        ldy #$00
        lda (sp),y
        sta tmp
        iny
        lda (sp),y
        sta tmp+1

        lda #$03
        ldy #$0

drawloop
        sta tmp1
        sty tmp1+1
        jsr $da0c       ; calculate address of Ath row on screen
        sta $1f
        ldx #$01

        ldy tmp1+1
        lda (tmp),y

        lda #$20
        jsr putpixel
        lda #$10
        jsr putpixel
        lda #$08
        jsr putpixel
        lda #$04
        jsr putpixel
        lda #$02
        jsr putpixel
        lda #$01
        jsr putpixel

        iny
        ldx tmp1
        inx
        txa
        cmp #$0b
        bne drawloop

        rts

_infopane
        jsr _itoa
        stx tmp1
        sta tmp1+1

        lda #$42
        sta tmp
        lda #$bd
        sta tmp+1

        ldy #$0
        lda (sp),y
        cmp #$64
        bcs threedigit
        lda #$30
        sta (tmp),y
        inc tmp
        lda (tmp1),y
        sta (tmp),y
        iny
        lda (tmp1),y
        sta (tmp),y
        jmp hexdisp

threedigit
        lda (tmp1),y
        sta (tmp),y
        iny
        cpy #$03
        bne threedigit

hexdisp
        lda #$48
        sta tmp
        ldy #$00
        lda (sp),y
        lsr A
        lsr A
        lsr A
        lsr A
        clc
        adc #$30

        sta (tmp),y
        lda (sp),y
        and #$0f
        cmp #$0a
        bcs alpha
        adc #$30
        jmp digit
alpha
        adc #$36
digit
        iny
        sta (tmp),y

        ldy #$0
        lda (sp),y
        ldy #$0b
        sta (tmp),y
        rts

_roll
        ldy #$0
        lda (sp),y
        sta tmp
        iny
        lda (sp),y
        sta tmp+1
        ldy #$0
rollloop
        lda (tmp),y
        clc
        rol A
        tax
        and #$40
        beq rollstore
        txa
        ora #$01
        jmp rollstore2
rollstore
        txa
rollstore2
        and #$3f
        sta (tmp),y
        iny
        cpy #$08
        bne rollloop
        rts

